// Simple test of USB Host Mouse
//
// This example is in the public domain
//
// Information on this driver can be found in mouse.cpp
// and USBHost_t36.h.
// It is an initial attempt.
// 
#include "USBHost_t36.h"

USBHost myusb;
USBHub hub1(myusb);
USBHub hub2(myusb);
USBHub hub3(myusb);

MouseController mouse1(myusb);

int16_t fine_dx = 0;
int16_t fine_dy = 0;
int16_t event_dx = 0;
int16_t event_dy = 0;
int16_t nevent_dx = 0;
int16_t nevent_dy = 0;

int16_t delta = 127;
int16_t accel = 2;
int16_t scaleX = 2;   
int16_t scaleY = 2;

uint8_t buttons;
int8_t mousex;
int8_t mousey;
int8_t wheel;
int16_t mouseXpos;
int16_t mouseYpos;

uint16_t tft_width = 800 - 1;
uint16_t tft_height = 480 - 1;
 
// This function is based loosely on the Linux GPM driver.
void scaleMouseXY(void) {
  
  nevent_dx = mousex;
  nevent_dy = mousey;
  
  if(abs(nevent_dx) + abs(nevent_dy) > delta) {
    nevent_dx *= accel;
    nevent_dy *= accel;
  }
  
  event_dx += nevent_dx;
  event_dy += nevent_dy;
  
  fine_dx += event_dx; 
  fine_dy += event_dy; 
  
  event_dx = fine_dx / scaleX;
  event_dy = fine_dy / scaleY;
  
  fine_dx %= scaleX;
  fine_dy %= scaleY;
  
  mouseXpos += event_dx;
  mouseYpos += event_dy;
  
  if(mouseXpos < 0)
    mouseXpos = 0;
  if(mouseXpos > tft_width)
    mouseXpos = tft_width;
  if(mouseYpos < 0)
    mouseYpos = 0;
  if(mouseYpos > tft_height)
    mouseYpos = tft_height;

}

void setup()
{
	while (!Serial) ; // wait for Arduino Serial Monitor
	Serial.println("USB Host Mouse Testing");
	myusb.begin();
}

void loop()
{
	myusb.Task();
  if(mouse1.available()) {
    buttons = mouse1.getButtons();
    wheel = mouse1.getWheel();
    mousex = mouse1.getMouseX();
    mousey = mouse1.getMouseY();
    
    scaleMouseXY();
    
    Serial.print("buttons = ");
    Serial.print(buttons,DEC);
    Serial.print(",  wheel = ");
    Serial.print(wheel,DEC);
    Serial.print(",  mouseXpos = ");
    Serial.print(mouseXpos,DEC);
    Serial.print(",  mouseYpos = ");
    Serial.println(mouseYpos,DEC);
    mouse1.mouseDataClear();
  }
  delay(50);
}




